#include <windows.h>
#include <process.h>
#include <stdio.h>

DWORD TLSIndex;

void setdata( int value )
{
  printf( "Thread %i: Set value = %i\n", GetCurrentThreadId(), value );
  TlsSetValue( TLSIndex, (void*)value );
}

void getdata()
{
  int value;
  value = (int)TlsGetValue( TLSIndex );
  printf( "Thread %i: Has value = %i\n", GetCurrentThreadId(), value );
}

unsigned int __stdcall workerthread( void * data )
{
  int value = (int)data;
  printf( "Thread %i: Got value = %i\n", GetCurrentThreadId(), value );
  setdata( value );
  Sleep( 1000 );
  getdata();
  return 0;
}

int _tmain( int argc, _TCHAR* argv[] )
{
  HANDLE handles[8];
  TLSIndex = TlsAlloc();
  for (int i=0; i<8; i++)
  {
    handles[i] = (HANDLE)_beginthreadex( 0, 0, &workerthread,
                                         (void*)i, 0, 0 );
  }
  for (int i=0; i<8; i++)
  {
    WaitForSingleObject( handles[i], INFINITE );
  }
  TlsFree( TLSIndex );
  getchar();
  return 0;
}
