#include <stdio.h>
#include <pthread.h>

volatile int priority = 0;
volatile int counter = 0;
volatile int waiting[2];

void increment( int i )
{
  waiting[i] = 1;

  while( waiting[1-i] == 1 )
  {
    if ( priority != i )
    {
       waiting[i] = 0;
       while ( priority != i ){}
       waiting[i] = 1;
    }
  }
  /* Critical section */
  counter++;
  /* Exit critical section */
  priority = 1-i;
  waiting[i] = 0;
}

void * worker( void * param )
{
  for ( int i=0; i<1000000; i++ )
  {
     increment( (int)param );
  }
}

int main()
{
  pthread_t threads[2];
  pthread_create( &threads[0], 0, worker, (void*)0 );
  pthread_create( &threads[1], 0, worker, (void*)1 );
  pthread_join( threads[1], 0 );
  pthread_join( threads[0], 0 );
  printf( "Errors = %i\n", 2*1000000 - counter );
}

