#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <pthread.h>
#include <sys/time.h>

#define BLOCKSIZE 1024*1025
int nthreads = 8;
char * memory;

double now()
{
  struct timeval time;
  gettimeofday( &time, 0 );
  return (double)time.tv_sec + (double)time.tv_usec / 1000000.0;
}

void *experiment( void *id )
{
  unsigned int seed = 0;
  int count = 20000;
  for( int i=0; i<count; i++ )
  {
    memset( &memory[BLOCKSIZE * (int)id], 0, BLOCKSIZE );
  }
  if ( seed == 1 ){ printf( "" ); }
}

int main( int argc, char* argv[] )
{
  pthread_t threads[64];
  memory = (char*)malloc( 64*BLOCKSIZE );
  if ( argc > 1 ) { nthreads = atoi( argv[1] ); }
  double start = now();
  for( int i=0; i<nthreads; i++ )
  {
    pthread_create( &threads[i], 0, experiment, (void*)i );
  }
  for ( int i=0; i<nthreads; i++ )
  {
    pthread_join( threads[i], 0 );
  }
  double end = now();
  printf( "%i Threads Time %f s Bandwidth %f GB/s\n", nthreads,
          (end - start), 
          ( (double)nthreads * BLOCKSIZE * 20000.0 ) /
          ( end - start) / 1000000000.0 );
  return 0;
}
