#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <pthread.h>

#include <sys/types.h>
#include <sys/processor.h>
#include <sys/procset.h>

int nthreads = 8;
volatile int busy = 1;

void * spin( void *id )
{
  processor_bind( P_LWPID, P_MYID, (int)id, 0 );
  while ( busy ) {}
}

void experiment( int id )
{
  unsigned int seed = 0;
  processor_bind( P_LWPID, P_MYID, id, 0 );
  int count = 100000000;
  for( int i=0; i<count; i++ )
  {
       seed += (seed<<2) ^ (seed|33556);
       seed += (seed<<2) ^ (seed|33556);
       seed += (seed<<2) ^ (seed|33556);
       seed += (seed<<2) ^ (seed|33556);
       seed += (seed<<2) ^ (seed|33556);
       seed += (seed<<2) ^ (seed|33556);
       seed += (seed<<2) ^ (seed|33556);
       seed += (seed<<2) ^ (seed|33556);
       seed += (seed<<2) ^ (seed|33556);
       seed += (seed<<2) ^ (seed|33556);
  }
  if ( seed == 1 ) { printf( "" ); }
}

int main( int argc, char* argv[] )
{
  pthread_t threads[64];
  if ( argc > 1 ) { nthreads = atoi( argv[1] ); }
  for( int i=0; i<nthreads; i++ )
  {
    pthread_create( &threads[i], 0, spin, (void*)(i+1) );
  }
  experiment( 0 );
  busy = 0;
  for( int i=0; i<nthreads; i++ )
  {
    pthread_join( threads[i], 0 );
  }
  return 0;
}
