#include <stdio.h>
#include <windows.h>
#include <process.h>

double now()
{
  return GetTickCount() / 1000.0;
}

int threadbind( int proc )
{
  DWORD_PTR mask;
  mask = 1<<proc ;
  return SetThreadAffinityMask( GetCurrentThread(), mask );
}


#define SIZE 128*1024*1024
int** memory;

void setup()
{
  int i, j;
  threadbind( 0 );
  memory = (int**)calloc( sizeof(int*), SIZE+1 );
  for( j=0; j<16; j++ ) 
  {
    for( i=16+j; i<=SIZE; i++ ) 
    { 
      memory[i] = (int*)&memory[ i-16 ]; 
    }
    memory[j] = (int*)&memory[ SIZE-16+j+1 ];
  }
}

unsigned int __stdcall use( void* param )
{
  if ( threadbind( (int)param ) != 0 ) 
  {
    int* next;
    int i;
    double start = now();
    next = memory[0];
    for( i=0; i<SIZE;i++ ) 
    { 
      next = (int*)*next; 
    }
    if ( (int)next == 1 ) { printf( "a" ); }
    double end = now();
    printf( "Time %14.2f ns Binding %i/s\n",
            (end-start)*1000000000.0 / ((double)SIZE), (int)param );
  } else { printf( "Error" ); }
  return 0;
}

int _tmain( int argc, _TCHAR* argv[] )
{
  HANDLE thread;
  int nthreads = 8;
  int i;
  if ( argc > 1 ) { nthreads = _wtoi( argv[1] ); }
  setup();
  for( i=0; i<nthreads; i++ ) 
  {
    thread = (HANDLE)_beginthreadex( 0, 0, &use, (void*)i, 0, 0 );
    WaitForSingleObject( thread, INFINITE );
    CloseHandle( thread );
  }
  getchar();
  return 0;
}
